<template>
  <div class="experience" ref="experience">
    <div class="intitule"> {{ experience.title }}</div>
    <div class="subtitle">
      {{ experience.subtitle }}
      <div class="dates">
        <div class="start"> {{ experience.dateStart | formatDate }}</div>
        <div class="end"> - {{ experience.dateEnd | formatDate }}</div>
      </div>
    </div>

    <div class="description">
      <div v-for="(task, index) in experience.tasks" :key="index">
        {{ task }}
      </div>
      <div class="technologies">
        Technologies utilisées : <br/>
        <span class="technologie" v-for="(techno, index) in experience.technologies" :key="index">
                      {{ techno }}
                    </span>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "Experience",
  props: {
    experience: {
      type: Object,
      required: true
    }
  },
  mounted() {
    window.addEventListener('scroll', this.checkPosition);
  },
  methods: {
    checkPosition(){
      const elem = this.$refs.experience;
      if(elem){
        const rect = elem.getBoundingClientRect()
        if(rect.top < window.innerHeight - 100 ){
          elem.classList.add('in')
          elem.classList.remove('hide')
        } else {
          elem.classList.add('hide')
          elem.classList.remove('in')
        }
      }
    }
  },
  filters: {
    formatDate(value) {
      const options = {year: 'numeric', month: 'short'};
      return value.toLocaleDateString(undefined, options);
    },
  }
}
</script>

<style lang="scss" scoped>
.experience {
  padding: 20px;
  border-radius: 5px;
  background-color: white;
  min-height: 80px;
}
.in {
  opacity: 1;
  visibility: visible;
  transition: ease 1s;
}

.hide {
  opacity: 0;
  visibility: hidden;
  transition: ease .5s;
}

.intitule {
  color: black;
  font-size: 26px;
  line-height: 1.28571;
  letter-spacing: -.4px;
  font-weight: bold;
}

.subtitle {
  color: #313131;
  font-size: 12px;
}

.dates {
  display: flex;
  flex-wrap: wrap;
  &:after{
   content: "";
   height: 1px;
   background-color: #31313133;
   width: 80%;
   align-self: center;
   justify-content: center;
   margin: 1em auto;
 }
}

.description {
  color: #313131;
  margin-top: 10px;
}

.technologie {
  font-weight: normal;
}
</style>
